# include "stdafx.h"
# include "UndoRedo.h"
# include "Map.h"
# include "Globals.h"

class CAddMapAction : public CEditAction {
  public:
	CAddMapAction (map_t * _pMap) :
		m_pMap (_pMap)
	{}

	virtual void GetName (std::string & _str) const;
	virtual bool CanUndo () const;
	virtual bool Do ();
	virtual void Undo ();
	virtual void Redo ();

  private:
	map_t * m_pMap;
};

bool AddMap (map_t * _pMap) {
	return PerformEditAction (new CAddMapAction (_pMap));
}

void CAddMapAction::GetName (std::string & _str) const {
	_str.append ("Add map");
}

bool CAddMapAction::Do () {
	CCritSec::CLock lock (g_cs);

	assert (m_pMap);
	g_map.Join (* m_pMap);

	return true;
}

bool CAddMapAction::CanUndo () const {return false;}
void CAddMapAction::Undo () {}
void CAddMapAction::Redo () {}

