# include "stdafx.h"
# include "UndoRedo.h"
# include "Map.h"
# include "Selection.h"
# include "Globals.h"

class CDeleteAttachmentAction : public CEditAction {
  public:
	CDeleteAttachmentAction (file_ref_t * _pFileRef) : m_pFileRef (_pFileRef) {}

	virtual void GetName (std::string & _str) const;
	virtual bool CanUndo () const;
	virtual bool Do ();
	virtual void Undo ();
	virtual void Redo ();

  private:
	file_ref_t * const m_pFileRef;
};

void DeleteAttachment (file_ref_t * _pFileRef) {
	PerformEditAction (new CDeleteAttachmentAction (_pFileRef));
}

void CDeleteAttachmentAction::GetName (std::string & _str) const {
	CCritSec::CLock lock (g_cs);

	assert (m_pFileRef);
	_str.append ("delete [");
	_str.append (m_pFileRef->strFileName);
	_str.append ("]");
}

bool CDeleteAttachmentAction::CanUndo () const {return true;}

bool CDeleteAttachmentAction::Do () {
	CCritSec::CLock lock (g_cs);

	assert (m_pFileRef);
	m_pFileRef->bDeleted = true;

	return true;
}

void CDeleteAttachmentAction::Undo () {
	CCritSec::CLock lock (g_cs);

	assert (m_pFileRef);
	m_pFileRef->bDeleted = false;
}

void CDeleteAttachmentAction::Redo () {CDeleteAttachmentAction::Do ();}

