# include "StdAfx.h"
# include "Resource.h"
# include "DragMap.h"
# include "Map.h"
# include "Settings.h"
# include "Position.h"
# include "MapView.h"
# include "Globals.h"

static HCURSOR g_hModeDragCursor;
static HCURSOR g_hDragCursor;
static HCURSOR g_hNoDragCursor;

bool CDragMode::Init () {
	assert (g_hInst);
	g_hModeDragCursor  = ::LoadCursor (g_hInst, MAKEINTRESOURCE (IDC_CursorModeDrag));
	g_hDragCursor      = ::LoadCursor (g_hInst, MAKEINTRESOURCE (IDC_CursorDrag));
	g_hNoDragCursor    = ::LoadCursor (g_hInst, MAKEINTRESOURCE (IDC_CursorNoDrag));

	return true;
}

void CDragMode::OnEnterMode () {
	SetPermanentCursor (g_hModeDragCursor);
}

void CDragMode::OnLDown (int _x, int _y, DWORD _dwKeys) {
	if (g_lTotalWidth <= g_lWidth && g_lTotalHeight <= g_lHeight) {
		SetPermanentCursor (g_hNoDragCursor);
	} else {
		SetPermanentCursor (g_hDragCursor);

		StartDND (_x, _y);
	}
}

void CDragMode::OnLUp (int _x, int _y, DWORD _dwKeys) {
	SetPermanentCursor (g_hModeDragCursor);

	if (! CMouseMode::s_bDND)
		return;
	StopDND ();

	bool bRefresh = false;
	if (_y != CMouseMode::s_lY_DND_Start) {
		SetX (g_lX - (_x - CMouseMode::s_lX_DND_Start));
		bRefresh = true;
	}
	if (_x != CMouseMode::s_lX_DND_Start) {
		SetY (g_lY + (_y - CMouseMode::s_lY_DND_Start));
		bRefresh = true;
	}
	if (bRefresh)
		Refresh ();
}

void CDragMode::OnMove (int _x, int _y, DWORD _dwKeys) {
	if (CMouseMode::s_bDND) {
		long lShiftX = CMouseMode::s_lX_DND_Start - _x;
		if (g_lX + lShiftX < 0)
			lShiftX = - g_lX;
		if (g_lX + lShiftX >= g_lTotalWidth - g_lWidth)
			lShiftX = - g_lX + g_lTotalWidth - g_lWidth - 1;

		long lShiftY = - (CMouseMode::s_lY_DND_Start - _y);
		if (g_lY + lShiftY < 0)
			lShiftY = - g_lY;
		if (g_lY + lShiftY >= g_lTotalHeight - g_lHeight)
			lShiftY = - g_lY + g_lTotalHeight - g_lHeight - 1;

		ShiftMap (lShiftX, lShiftY);
	}
}

