# include "stdafx.h"
# include "Globals.h"
# include "Log.h"
# include "GarminImg.h"

// Umrechenwert Garmin->Grad
const double c_ko230 = (1UL << 30)/90.;

// liest ab abstart in der datei datnr 3 byte aus und
// rechnet in grad um (absolut, -180 bis +180)
float hexgrad_3byte (const BYTE * _strData) {
    // die drei Bytes werden in eine dez.Zahl umgerechnet
	const BYTE b0 = _strData [0];
	const BYTE b1 = _strData [1];
	const BYTE b2 = _strData [2];
    float grad = (DWORD (b2) << 16) + (DWORD (b1) << 8) + DWORD (b0);
    // wenn der Hexwert neg. ist (2nd)-> dez. auch neg.
    if (grad >= 8388608)
        grad = (grad - 16777216)*256/c_ko230;
    else
        grad = grad*256/c_ko230;
	return grad;
}

// longwert (4 byte) zu gradwert zusammenbauen
long wertlong (tre2asec_t * tre2asec, long grad, long k, long v) {
	long r = 0;

    if (grad >= 32768)
        r = grad - 65536;
    else
        r = grad;
    r *= tre2asec [k].l9;

	long gradl;
    if (v >= 8388608)
        gradl = (v - 16777216) * 256;
    else
        gradl = v * 256;
	r += gradl;

	return r;
}

std::string lblzeichen (BYTE & bl1, short zx) {
	std::string ret;
    if (bl1 == 1) { // after 0x1C
        if (zx == 0)
			ret = '@';
		else if (zx == 2)                 // " in ' ndern
            ret = '\'';
        else if (zx >= 1 && zx <= 0xF)
            ret = (char) (0x20 + zx);
        else if (zx >= 0x1A && zx <= 0x1F)
            ret = (char) (0x20 + zx);
        else if (zx >= 0x2B && zx <= 0x2F)
			ret = (char) (0x30 + zx);
        else {
            ret = "";
            ReportWarning ("Unexpected symbol in label: 0x1c, 0x%02x", zx);
        }
        bl1 = 0;
        return ret;
    } else if (bl1 == 2) {  // after 0x1B
        if (zx >= 0 && zx <= 0x1A) {      // zeichen a-z
			ret = "~[0x1b]";
			ret += (char) (0x40 + zx);
		} else if (zx >= 0x20 && zx <= 0x29) {   // zahlen 0-9
            ret = "~[0x1b]";
			ret += (char) (0x10 + zx);
        } else if (zx == 0x2B)
			ret = (char) 187;
		else if (zx == 0x2C)
			ret = (char) 171;
		else {
			ret = "";
			ReportWarning ("Unexpected symbol in label: 0x1b, 0x%02x", zx);
		}
        bl1 = 0;
        return ret;
    }

	if (zx >= 1 && zx <= 0x1A)  // a-z
		ret = (char) (0x40 + zx);
    else switch (zx) {
        case 0:
            return " ";
        case 0x1B:
			bl1 = 2;
            return "";
        case 0x1C:       // sonderzeichen
            bl1 = 1;
            return "";
        case 0x1D:
            return "~[0x1d]";
        case 0x1E:
            ret = (char) 187;
			return ret;
        case 0x1F:
            ret = (char) 171;
			return ret;
        case 0x20:   // 0-9
		case 0x21:
		case 0x22:
		case 0x23:
		case 0x24:
		case 0x25:
		case 0x26:
		case 0x27:
		case 0x28:
		case 0x29:
            ret = (char) (0x10 + zx);
			return ret;
        case 0x2A: // Interstate highway
            return "~[0x2a]";
        case 0x2B: // Highway - shield
            return "~[0x2b]";
        case 0x2C: // Highway - round symbol
            return "~[0x2c]";
        case 0x2D: // Highway - small symbol - blue/red
            return "~[0x2d]";
        case 0x2E: // Highway - big symbol
            return "~[0x2e]";
        case 0x2F: // Highway - small symbol - white
            return "~[0x2f]";
        default:
            ReportWarning ("Unexpected symbol in label: %02x", zx);
            return "";
    }

	return ret;
}
/*
abschneiden ?
Abschnitt	
angezeigt	
Anzahl		
anzeigen	 ()
Ausgabe		()
auswerten	

Befehle		
Berechnung	
Bereich		
bestimmen	, , 
bezug		()

dahinter	 
da			

einlesen	
Eintrag		 ()
entfernen	
erlauben	
ermitteln	

fall		
festlegen	 ()
fla:che		
folge		  

holen		?

Inhalt		
kurz		

laden		 ()
La:nge		
lauter		
liefert		
leer		
lo:schen	

mitte		

o:ffnen		
ort			

rechnen		
Schleifen	c
solderfall	?
Speicher	

umrechnen	
umwandeln	
ungu:ltig	
unbekannt	

vorher		
vorzeichen	?
Wert		 ()

Zahl		
Zeiger		
Zeichen		, 
Zeile		
za:hlen		
Zusatz		
*/
/*
   :
1/2 Net
 NOD
 SRT
 MDR

 RGN,    .

Alecs 
*/
