//
// Based on code published at
// http://gps.boston.ru/cgi-bin/forum/showpost.pl?Board=gpsgeneral&Number=10570&Search=true&Forum=gpsgeneral&Words=Columb&Match=Username&Searchpage=21&Limit=25&Old=1year
//

#ifdef _MSC_VER
#pragma pack (push, 1)
#endif

struct CImgHeader {
	BYTE zero0000 [10];

	BYTE btMonth;
	BYTE btYear;

	BYTE zero000c [3];
	BYTE bt000f;        // '9'

	BYTE strSignature [7]; // "DSKIMG\0"

	BYTE byte0017 [9];
	BYTE zero0020 [16];
	BYTE zero0030 [9];
	BYTE byte0039 [7];
	BYTE bt0040;

	BYTE strGarmin [8]; // "GARMIN\0\0"
	BYTE strName [22]; // "mapname???\x10\0"

	BYTE bt005f; 
	BYTE bt0060; // 00

	BYTE btBlockSizePowerOf2_1; // 09
	BYTE btBlockSizePowerOf2_2; // 02
	WORD GetBlockSize () const {
		return 1 << (btBlockSizePowerOf2_1 + btBlockSizePowerOf2_2);
	}

	BYTE byte0064 [2]; // 00 08

	BYTE strName2 [31]; // 30 spaces \0

	BYTE zero0084[12]; 
	BYTE zero0090[19*16]; 
	BYTE byte01c0[16];
	BYTE zero01d0[32]; 
	BYTE zero01f0[14]; 
	BYTE byte01fe[2]; // Uk (55 aa)
	BYTE byte0200[512];
	BYTE byte0400[12];

	DWORD dwDataOffset;

	BYTE byte0410 [512 - 16];
};

struct CImgIndexBlock {
	BYTE btOne;      // Must be equal to 1.
	BYTE strCode [8]; // I02034A6
	BYTE strType [3]; // RGN, TRE, LBL, NET
	DWORD dwLength; // 
	BYTE btZero010; 
	BYTE btIndex; 
	BYTE zero012[14];
	WORD wSize;
	WORD dataBlockNumbers[239];
	// BYTE reserv[512-32];
};

struct CDataBlockHead {
	WORD wHeaderLength; // 0x1d-RGN, 0x78-TRE, 0xd0-LBL, 0x37-NET,
	BYTE strLabel [10]; // 02: 'GARMIN RGN', 'GARMIN TRE', 'GARMIN LBL', or 'GARMIN NET'

	WORD w000c; // 0c: 0x0001

	WORD year; // 0e: 
	BYTE mon; // 10:
	BYTE day; // 11:
	BYTE hour; // 12:
	BYTE min; // 13: 
	BYTE sec; // 14:
};

typedef BYTE B3_t [3];

struct CTreDataBlockHead : public CDataBlockHead {
	// Map boundaries.
	B3_t b3MapNorth; // 15:
	B3_t b3MapEast; // 18:
	B3_t b3MapSouth; // 1b:
	B3_t b3MapWest; // 1e: - 20

	// TRE1 - zone definitions
	DWORD dwZonesOffset; // 21:
	DWORD dwZonesLength; // 25:

	// TRE2 - definitions RGN1 parts in zones
	DWORD sec2_offset; // 29:
	DWORD sec2_len; // 2D:

	// TRE3 - pointer to CR
	DWORD sec3_offset; // 31: 
	DWORD sec3_len; // 35:
	DWORD sec3_recSize; // 39: ??

	WORD  zero003d; // 3d: 00 00 

	// Unknown data block: 0d 1e 00 00 01 03 0e 00 01 00 00
	DWORD long03f; // 3f: TRE7 - ??? 
	DWORD long043; // 43:-46
	WORD  short047;
	BYTE  zero049; // 47:-49

	// Types of plylines.
	DWORD sec4_offset; // 4a:
	DWORD sec4_len; // 4e:
	DWORD sec4_recSize; // 52:

	WORD  zero056; // 56:

	// Types of polygons.
	DWORD sec5_offset; // 58: TRE5 fill types
	DWORD sec5_len; // 5c:
	DWORD sec5_recSize; // 60:

	WORD  zero064; // 64:

	// Types of POI and points.
	DWORD sec6_offset; // 66:
	DWORD sec6_len; // 6a:
	DWORD sec6_recSize; // 6e:-51
	WORD  zero072; // 72: 0x0000

	DWORD dwMapID; // 74:

	BYTE  strHeader [32]; // 78:-97 32=20
	BYTE  strCopyright [43]; // 98:-c3 43=2A

	// 0000c3: sec3
	// 0000c9: sec1
	// 0000dd: sec2
	// 005d2d: sec4
	// 005d45: sec5
	// 005d67: sec6
};

struct CRgnDataBlockHead : public CDataBlockHead {
	DWORD dwOffset;
	DWORD dwLength;
};

struct tre2asec_t {
	long l1; //+rgn1 offset
	long l2; //inhalt
	long l3; //ostwert
	long l4; //nordwert
	long l5; //zusatz 1
	long l6; //zusatz 2
	long l7; //zusatz 3
	long l8; // zone
	long l9; // zf
	long l10; // beg-punkt oder -1
	long l11; // len-punkt oder -1
	long l12; // beg-orte oder -1
	long l13; // len-orte oder -1
	long l14; // beg-line oder -1
	long l15; // len-line oder -1
	long l16; // beg-area oder -1
	long l17; // len-area oder -1
};

struct tre1sec_t {
	BYTE lev; // level
	BYTE zf;  // zonenfaktor
	short n;   // Anzahl der eintrge je zone in TRE2
};

struct tre4sec_t {
	BYTE bt1, bt2;
};

struct tre5sec_t {
	BYTE bt1, bt2;
};

struct tre6sec_t {
	short sh1, sh2;
};


#ifdef _MSC_VER
#pragma pack (pop, 1)
#endif

float hexgrad_3byte (const BYTE * _strData);
long wertlong (tre2asec_t * tre2asec, long grad, long k, long v);
std::string lblzeichen (BYTE & bl1, short zx);