const float c_PI = 3.14159265358979f;
const float c_Sqrt4 = 1.189207115f;

const float c_feet_per_m = 3.28084f;

////////////////////////////////////////////////////////////////

inline
size_t Align4 (size_t _c) {
	if (_c & 0x3)
		_c += 4 - (_c & 0x3);
	assert (_c % 4 == 0);
	return _c;
}

inline
size_t Align2 (size_t _c) {
	if (_c & 0x1)
		++ _c;
	assert (_c % 2 == 0);
	return _c;
}

long fast_floor (float _f);

///////////////////////////////////////

class COutOfMemory : public std::runtime_error {
  public:
	COutOfMemory (size_t _size);
};

///////////////////////////////////////

# ifdef _DEBUG
	# define MAIN_TITLE "GPSMap Edit (DEBUG)"
# else
	# define MAIN_TITLE "GPSMap Edit"
# endif // _DEBUG

void UpdateTitle ();

extern char g_strFileName [MAX_PATH + 1];
extern bool g_bTypeCanBeSaved;

void ErrorMsgBox (const char * _strFormat, ...);

extern bool g_bDialogMode;

extern bool g_bNT;

extern HINSTANCE g_hInst;
extern HWND g_hWnd;
extern HACCEL g_hAccelTable;

/////////////////////////////////////////////

typedef BOOL (WINAPI * pfAlphaBlend_t) (HDC hdcDest, int nXOriginDest, int nYOriginDest, int nWidthDest, int nHeightDest, HDC hdcSrc, int nXOriginSrc, int nYOriginSrc, int nWidthSrc, int nHeightSrc, BLENDFUNCTION blendFunction);
extern pfAlphaBlend_t g_fpAlphaBlend;

/////////////////////////////////////////////

class CWaiter {
  public:
	CWaiter ();
	~CWaiter ();
};

/////////////////////////////////////////////

extern HFONT g_hFont;

const COLORREF c_colBlack   = RGB (0,   0,   0);
const COLORREF c_colWhite   = RGB (255, 255, 255);
const COLORREF c_colLtGray  = RGB (192, 192, 192);
const COLORREF c_colGray    = RGB (128, 128, 128);
const COLORREF c_colDkGray  = RGB (96,  96,  96);
const COLORREF c_colRed     = RGB (255, 0,   0);
const COLORREF c_colDkRed   = RGB (192, 0,   0);
const COLORREF c_colGreen   = RGB (0,   255, 0);
const COLORREF c_colDkGreen = RGB (0,   192, 0);
const COLORREF c_colBlue    = RGB (0,   0,   255);
const COLORREF c_colDkBlue  = RGB (0,   0,   192);
const COLORREF c_colYellow  = RGB (255, 255, 0);
const COLORREF c_colCyan    = RGB (0,   255, 255);

extern HPEN g_hNullPen;
extern HPEN g_hBlackThinPen;
extern HPEN g_hGrayThinPen;
extern HPEN g_hWhiteThickPen;
extern HPEN g_hGridPen;

extern HBRUSH g_hNullBrush;
extern HBRUSH g_hTmpBrush;
extern HBRUSH g_hBlackBrush;
extern HBRUSH g_hGrayBrush;
extern HBRUSH g_hWhiteBrush;

extern HBRUSH g_hWhiteHatchedBrush;


