# include "stdafx.h"
# include "Map.h"
# include "Types.h"
# include "Label.h"
# include "Globals.h"

bool IsLabelCorrect (const char * _str) {
	for (const char * p = _str; * p; ++ p)
		if (::strchr (" abcdefghijklmnopqrstuvwxyz0123456789@!\"#$%&'()*+,-./:;<=>?[\\]", ::tolower (* p)) == NULL) {
			if (
				p [0] == '~' &&
				p [1] == '[' &&
				p [2] == '0' &&
				p [3] == 'x' &&
				::isxdigit (p [4]) &&
				::isxdigit (p [5]) &&
				p [6] == ']'
			)
				continue;
			return false;
		}
	return true;
}

void GetHintText (const rgn_t & _rgn, std::string & _strText) {
	const char * strTypeName = _rgn.pTypeDesc->strTypeName;
	if ((_rgn.dwFlags & rgn_t::fWaypointOrTrack) && _rgn.pTypeDesc == g_types)
		strTypeName = _rgn.ushKind == 0 ? "Waypoint" : "Track";

	if (! _rgn.strLabel.empty ()) {
		char * const str = reinterpret_cast<char *> (::alloca (_rgn.strLabel.size () + 4 + ::strlen (_rgn.pTypeDesc->strTypeName)));

		// TODO: handle such strings as well.
		if (::strncmp (_rgn.strLabel.c_str (), "~[0x", 4) == 0)
			::strcpy (str, _rgn.strLabel.c_str () + 7);
		else
			::strcpy (str, _rgn.strLabel.c_str ());
		::strcat (str, " (");
		::strcat (str, strTypeName);
		::strcat (str, ")");

		_strText.append (str);
	} else
		_strText.append (strTypeName);
}