# ifndef __MouseMode_H_
# define __MouseMode_H_

extern HCURSOR g_hArrowCursor;
extern HCURSOR g_hWaitCursor;

	// Current cursor: permanent or 'wait' one.
extern HCURSOR g_hCursor;
	// Permanent cusor.
extern HCURSOR g_hPermanentCursor;

///////////////////////////////////////////

class CMouseMode {
  public:
	virtual bool Init () {return true;}

	virtual void OnNewMap () {}
	virtual void OnEnterMode () {}
	virtual void OnLeaveMode () {}

	virtual void OnLDown (int _x, int _y, DWORD _dwKeys) {}
	virtual void OnLUp   (int _x, int _y, DWORD _dwKeys) {}
	virtual void OnLDblClk (int _x, int _y, DWORD _dwKeys) {OnLDown (_x, _y, _dwKeys);}
	virtual void OnRDown (int _x, int _y, DWORD _dwKeys) {}
	virtual void OnRUp   (int _x, int _y, DWORD _dwKeys) {}
	virtual void OnMove  (int _x, int _y, DWORD _dwKeys) {}

	virtual void OnEsc () {}
	virtual void OnEnter () {}
	virtual bool OnCommand (WORD _wID) {return false;}

	virtual void OnPaint (HDC _hDC) {}

	//////////////////////////

	static void Set (size_t _cModeIndex);
	static bool PendingDND () {return s_bDND;}
	static void SetPermanentCursor (HCURSOR _hcur);

	static bool _Init ();
	static void _OnNewMap ();
	static void _OnEsc   () {if (s_pMode) s_pMode->OnEsc ();}
	static void _OnEnter () {if (s_pMode) s_pMode->OnEnter ();}
	static void _OnLDown   (int _x, int _y, DWORD _dwKeys) {if (s_pMode) s_pMode->OnLDown   (_x, _y, _dwKeys);}
	static void _OnLDblClk (int _x, int _y, DWORD _dwKeys) {if (s_pMode) s_pMode->OnLDblClk (_x, _y, _dwKeys);}
	static void _OnLUp     (int _x, int _y, DWORD _dwKeys) {if (s_pMode) s_pMode->OnLUp     (_x, _y, _dwKeys);}
	static void _OnRDown   (int _x, int _y, DWORD _dwKeys) {if (s_pMode) s_pMode->OnRDown   (_x, _y, _dwKeys);}
	static void _OnRUp     (int _x, int _y, DWORD _dwKeys) {if (s_pMode) s_pMode->OnRUp     (_x, _y, _dwKeys);}
	static void _OnMove    (int _x, int _y, DWORD _dwKeys);
	static void _OnPaint (HDC _hDC)       {if (s_pMode) s_pMode->OnPaint (_hDC);}
	static bool _OnCommand (WORD _wID)    {
		if (s_pMode)
			return s_pMode->OnCommand (_wID);
		else
			return false;
	}

  private:
	static CMouseMode * s_pMode;

  protected:
	// Drag-and-drop flag
	static bool s_bDND;
	// Drag-and-drop start position.
	static long s_lX_DND_Start, s_lY_DND_Start;
	// Drag-and-drop current position.
	static long s_lX_DND, s_lY_DND;

	void StartDND (long _lX, long _lY);
	void StopDND ();
};

# endif // __MouseMode_H_