# include "stdafx.h"
# include "Map.h"
# include "UndoRedo.h"
# include "Log.h"
# include "Menu.h"
# include "Status.h"
# include "Save.h"
# include "NewMap.h"
# include "Scale.h"
# include "Position.h"
# include "MapView.h"
# include "Position.h"
# include "Selection.h"
# include "MouseMode.h"
# include "Globals.h"

void RemoveMap () {
	if (! RequestSave ())
		return;

	ResetUndoRedo ();
	g_bModified = false;

	CMouseMode::_OnNewMap ();

	// Update title.
	g_strFileName [0] = '\0';
	UpdateTitle ();

	// Disable mini-window.
	g_lMiniW = 0;
	g_lMiniH = 0;
	::SetWindowPos (g_hMiniMapWnd, NULL, 0, 0, g_lMiniW, g_lMiniH, SWP_NOMOVE | SWP_NOZORDER);

	ResetStatus ();
	{
		CWaiter w;
		CCritSec::CLock lock (g_cs);
		g_map.Init ();
		g_Selection.clear ();
	}
	RefreshScales ();
	Refresh ();

	ClearLog ();

	UpdateMenu ();
}
