# include "stdafx.h"
# include "Position.h"
# include "Scale.h"
# include "Map.h"
# include "Globals.h"

	// Size of the window in pixels.
long g_lWidth = 0, g_lHeight = 0;
	// Size of the map in pixels.
long g_lTotalWidth, g_lTotalHeight;

	// Shift of the window in degrees.
float g_X, g_Y;
	// Shift of the window in pixels.
long g_lX, g_lY;

long XToScreen (float _x) {return                 fast_floor (.5 + g_kX*(_x - g_map.rectBound.x0 - g_X));}
long YToScreen (float _y) {return g_lHeight - 1 - fast_floor (.5 + g_kY*(_y - g_map.rectBound.y0 - g_Y));}

void ScreenToPt (int _x, int _y, point_t & _point) {
	_point.x = g_map.rectBound.x0 + (g_lX + _x)/g_kX;
	_point.y = g_map.rectBound.y0 + (g_lY + g_lHeight - _y)/g_kY;
}

void GetVisibleRect (rect_t & _rectVisible) {
	CCritSec::CLock lock (g_cs);

	_rectVisible.x0 = g_map.rectBound.x0 + g_X;
	_rectVisible.y0 = g_map.rectBound.y0 + g_Y;
	_rectVisible.x1 = _rectVisible.x0 + g_lWidth/g_kX;
	_rectVisible.y1 = _rectVisible.y0 + g_lHeight/g_kY;
}

void SetX (long _lX) {
	if (_lX == g_lX)
		return;
	if (_lX < 0)
		_lX = 0;
	if (_lX > g_lTotalWidth - g_lWidth)
		_lX = g_lTotalWidth - g_lWidth - 1;

	g_lX = _lX;
	g_X = g_lX/g_kX;
}

void SetY (long _lY) {
	if (_lY == g_lY)
		return;
	if (_lY < 0)
		_lY = 0;
	if (_lY > g_lTotalHeight - g_lHeight)
		_lY = g_lTotalHeight - g_lHeight - 1;

	g_lY = _lY;
	g_Y = g_lY/g_kY;
}

void SetToCenter (const point_t & _point) {
	CCritSec::CLock lock (g_cs);

	g_X = _point.x - g_map.rectBound.x0 - .5*g_lWidth/g_kX;
	g_Y = _point.y - g_map.rectBound.y0 - .5*g_lHeight/g_kY;

	g_lX = g_X*g_kX;
	g_lY = g_Y*g_kY;
}
