# ifndef __Save_H_
# define __Save_H_

bool RequestSave ();
void SaveMap (const char * _strFileName);
void SaveMapAs ();

//////////////////////////////////////

class CMapSaver {
  public:
	virtual void Save (HANDLE _hFile, const char * _strFileName, map_t * _pMap) = 0;
};

//////////////////////////////////////

class CTxtSaver : public CMapSaver {
  public:
	virtual void Save (HANDLE _hFile, const char * _strFileName, map_t * _pMap);

  private:
	void FlushBuffer ();

	void WriteS (const char * _str);
	void WriteC (char _c);
	void WriteU (unsigned _u);
	void WriteFraction (float _f);
	void WriteX (unsigned _x);
	void WriteF (float _f);

	HANDLE m_hFile;

	size_t m_cPrecOrder;
	float m_fPrecFactor;
};

# endif // __Save_H_