# include "stdafx.h"
# include "Selection.h"
# include "Position.h"
# include "Scale.h"
# include "MapView.h"
# include "Menu.h"
# include "Load.h"

find_info_m_t g_Selection;

find_info_t FindRgn (int _x, int _y) {
	if (g_bLoading)
		return find_info_t ();

	CCritSec::CLock lock (g_cs);

	point_t p;
	p.x = g_map.rectBound.x0 + g_X + _x/g_kX;
	p.y = g_map.rectBound.y0 + g_Y + (g_lHeight - _y)/g_kY;

	return g_map.FindRgn (p);
}

void SelectObjectAt (int _x, int _y, bool _bAdd, bool _bElementOnly) {
	find_info_t Selection = FindRgn (_x, _y);
	if (Selection.pLayer && ! _bElementOnly) {
		Selection.cElement = -1;
		Selection.cOrigin = -1;
	}

	bool bRedraw = false;

	if (Selection.empty ()) {
		if (! _bAdd) {
			g_Selection.clear ();
			bRedraw = true;
		}
	} else {
		const find_info_m_t::iterator i = std::find (g_Selection.begin (), g_Selection.end (), Selection);
		if (i != g_Selection.end ()) {
			if (_bAdd) {
				g_Selection.erase (i);
				bRedraw = true;
			}
		} else {
			if (! _bAdd)
				g_Selection.clear ();
			g_Selection.push_back (Selection);
			bRedraw = true;
		}
	}

	// Redraw map with new selection.
	if (bRedraw) {
		Redraw ();
		UpdateMenu ();
	}
}

void UnselectObjects () {
	if (g_Selection.empty ())
		return;

	g_Selection.clear ();

	// Redraw map without selection.
	Redraw ();
	UpdateMenu ();
}

