# include "stdafx.h"
# include "Settings.h"
# include "Globals.h"

HKEY g_hkeySettings;

void InitRegistryAccess () {
	DWORD dwDisposition;
	if (
		::RegCreateKeyEx (
			HKEY_CURRENT_USER, "Software\\KG\\GPSMapEdit", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, & g_hkeySettings, & dwDisposition
		) != ERROR_SUCCESS
	)
		g_hkeySettings = NULL;
}

DWORD GetSetting (const char * _strName, DWORD _dwDefault) {
	if (! g_hkeySettings)
		return _dwDefault;

	DWORD dwRet = 0;
	DWORD dwType = 0;
	DWORD dwSize = sizeof (DWORD);
	if (
		::RegQueryValueEx (
			g_hkeySettings, _strName, NULL, & dwType, reinterpret_cast<BYTE *> (& dwRet), & dwSize
		) != ERROR_SUCCESS ||
		dwType != REG_DWORD ||
		dwSize != sizeof (DWORD)
	)
		return _dwDefault;

	return dwRet;
}

bool GetSetting (const char * _strName, bool _bDefault) {
	return GetSetting (_strName, _bDefault ? (DWORD) 1 : (DWORD) 0) != 0;
}

void GetSetting (const char * _strName, char * _strRet, size_t _cSize, const char * _strDefault) {
	if (! g_hkeySettings) {
		::strcpy (_strRet, _strDefault);
		return;
	}

	DWORD dwType = 0;
	DWORD dwSize = _cSize;
	if (
		::RegQueryValueEx (
			g_hkeySettings, _strName, NULL, & dwType, reinterpret_cast<BYTE *> (_strRet), & dwSize
		) != ERROR_SUCCESS ||
		dwType != REG_SZ
	)
		::strcpy (_strRet, _strDefault);
}

void SaveSetting (const char * _strName, DWORD _dwValue) {
	if (! g_hkeySettings)
		return;

	::RegSetValueEx (g_hkeySettings, _strName, 0, REG_DWORD, reinterpret_cast<const BYTE *> (& _dwValue), sizeof (DWORD));
}

void SaveSetting (const char * _strName, bool _bValue) {
	SaveSetting (_strName, _bValue ? (DWORD) 1 : (DWORD) 0);
}

void SaveSetting (const char * _strName, const char * _strValue) {
	if (! g_hkeySettings)
		return;

	::RegSetValueEx (g_hkeySettings, _strName, 0, REG_SZ, reinterpret_cast<const BYTE *> (_strValue), ::strlen (_strValue));
}
