# include "stdafx.h"
# include "Status.h"
# include "Toolbar.h"
# include "Levels.h"
# include "Scale.h"
# include "Globals.h"

HWND g_hStatusWnd;

bool InitStatusWindow () {
	assert (g_hWnd);

	g_hStatusWnd = ::CreateStatusWindow (WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | SBT_TOOLTIPS, "No file(s)", g_hWnd, 101);
	if (! g_hStatusWnd)
		return false;

	int widths [] = {100, 108, 40, 20, 70, 50, 20, 135};
	for (size_t c = 1; c < sizeof (widths)/sizeof (widths [0]); ++ c)
		widths [c] += widths [c - 1];
	::SendMessage (g_hStatusWnd, SB_SETPARTS, sizeof (widths)/sizeof (widths [0]), long (widths));
	::SendMessage (g_hStatusWnd, SB_SETTEXT, 3 | SBT_NOBORDERS, long (NULL));
	::SendMessage (g_hStatusWnd, SB_SETTEXT, 6 | SBT_NOBORDERS, long (NULL));

	return true;
}

void ResetStatus () {
	SetStatus ("No file(s)");
	SetProgressStatus (0);
	::SendMessage (g_hStatusWnd, SB_SETTEXT, 2, long (""));
	::SendMessage (g_hStatusWnd, SB_SETTEXT, 4, long (""));
	::SendMessage (g_hStatusWnd, SB_SETTEXT, 5, long (""));
	::SendMessage (g_hStatusWnd, SB_SETTEXT, 7, long (""));

	if (g_hScaleCB)
		::SendMessage (g_hScaleCB, WM_SETTEXT, 0, (LPARAM) "");
}

const char * g_strStatus = "";

void SetStatus (const char * _strStatus) {
	if (strcmp (_strStatus, g_strStatus) == 0)
		return;

	g_strStatus = _strStatus;

	::SendMessage (g_hStatusWnd, SB_SETTEXT, 0, long (g_strStatus));
}

int g_iProgress = 0;

void SetProgressStatus (int _iProgress) {
	if (_iProgress > 100)
		_iProgress = 100;
	if (_iProgress < 0)
		_iProgress = 0;

	if (_iProgress == g_iProgress)
		return;
	g_iProgress = _iProgress;

	::SendMessage (g_hStatusWnd, SB_SETTEXT, 1 | SBT_OWNERDRAW, g_iProgress);

	char strText [20];
	::sprintf (strText, "% 3d%%", g_iProgress);
	::SendMessage (g_hStatusWnd, SB_SETTEXT, 2, long (strText));
}

void SetCoordinatesStatus (float _x, float _y) {
	if (_x < -180)
		_x = -180;
	if (_x > 180)
		_x = 180;

	if (_y < -90)
		_y = -90;
	if (_y > 90)
		_y = 90;

	char strText [64];
	::sprintf (strText, "%s %.5f, %s %.5f", _y > 0 ? "N" : "S", ::fabs (_y), _x > 0 ? "E" : "W", ::fabs (_x));
	::SendMessage (g_hStatusWnd, SB_SETTEXT, 7, long (strText));
}

void SetScaleStatus (float _fScale) {
	char strText [64];
	::sprintf (strText, "1 : %d", long (_fScale*c_pixels_per_cm*100));
	::SendMessage (g_hStatusWnd, SB_SETTEXT, 4, long (strText));

	char strText2 [64];
	GetZoomLevel (_fScale, strText2);
	::SendMessage (g_hStatusWnd, SB_SETTEXT, 5, long (strText2));

	char strText3 [20];
	GetScale (_fScale, strText3);
	if (g_hScaleCB)
		::SendMessage (g_hScaleCB, WM_SETTEXT, 0, (LPARAM) strText3);
}

